Index: src/web100srv.c
===================================================================
--- src/web100srv.c	(revision 796)
+++ src/web100srv.c	(working copy)
@@ -86,6 +86,8 @@
 #include "strlutils.h"
 #include "heuristics.h"
 #include "tests_srv.h"
+#include "kernel_coalesce.h"
+#include "kernel_config.h"
 
 static char lgfn[FILENAME_SIZE];  // log file name
 static char wvfn[FILENAME_SIZE];  // file name of web100-variables list
@@ -166,6 +168,7 @@
   { "record", 0, 0, 'r' }, { "syslog", 0, 0, 's' },
   { "tcpdump", 0, 0, 't' }, { "version", 0, 0, 'v' },
   { "gzip", 0, 0, 'z' }, { "config", 1, 0, 'c' },
+  { "kernelconfig", 0, 0, 'k'},
 #ifdef EXPERIMENTAL_ENABLED
   { "avoidsndblockup", 0, 0, 306},
   { "snaplog", 0, 0, 307},
@@ -457,6 +460,13 @@
         exit(-2);
       break;
     case SIGINT:
+      if(getpid() == ndtpid){
+        revert_coalesce();
+        revert_congestion();
+#ifndef FORCE_WEB100
+        revert_tcpe();
+#endif
+      }
       exit(0);
     case SIGTERM:
       if (getpid() == ndtpid) {
@@ -466,19 +476,28 @@
             ndtpid);
         break;
       }
+      if(getpid() == ndtpid){
+        revert_coalesce();
+        revert_congestion();
+#ifndef FORCE_WEB100
+        revert_tcpe();
+#endif
+      }
       exit(0);
     case SIGUSR1:
+      /* SIGUSR1 is used exclusively by C2S, to interrupt the pcap capture*/
       log_println(6,
-                  "DEBUG, caught SIGUSR1, setting sig1 flag to force exit");
+                  "DEBUG, caught SIGUSR1, setting sig1 flag and calling force_breakloop");
+      force_breakloop();
       sig1 = 1;
-      /* check_signal_flags(); */
       break;
 
     case SIGUSR2:
+      /* SIGUSR2 is used exclusively by S2C, to interrupt the pcap capture*/
       log_println(6,
-                  "DEBUG, caught SIGUSR2, setting sig2 flag to force exit");
+                  "DEBUG, caught SIGUSR2, setting sig2 flag and calling force_breakloop");
+      force_breakloop();
       sig2 = 1;
-      /* check_signal_flags(); */
       break;
 
     case SIGALRM:
@@ -552,8 +571,7 @@
 
     case SIGHUP:
       /* Initialize Web100 structures */
-      count_vars = web100_init(VarFileName);
-
+      count_vars = tcp_stat_init(VarFileName);
       /* The administrator view automatically generates a usage page for the
        * NDT server.  This page is then accessable to the general public.
        * At this point read the existing log file and generate the necessary
@@ -628,8 +646,12 @@
       set_debuglvl(atoi(val));
       continue;
     } else if (strncasecmp(key, "variable_file", 6) == 0) {
+#ifdef FORCE_WEB100
       snprintf(wvfn, sizeof(wvfn), "%s", val);
       VarFileName = wvfn;
+#else
+      log_println(0, "WEB10G doesn't need a variable file, ignoring");
+#endif
       continue;
     } else if (strncasecmp(key, "log_file", 3) == 0) {
       snprintf(lgfn, sizeof(lgfn), "%s", val);
@@ -834,12 +856,6 @@
           recv_msg(tmp_ptr->ctlsockfd, &msgType, buff, &msgLen);
           tmp_ptr = tmp_ptr->next;
           pre_ptr = pre_ptr->next;
-          /*
-             if ((sig1 > 0) || (sig2 > 0))
-             check_signal_flags();
-             if (sig17 > 0)
-             child_sig(0);
-             */
           break;
         case -1:  // some error status
           if (errno == EINTR) {
@@ -899,8 +915,9 @@
  * @param test_suite pointer to string indicating tests to be run
  * */
 
-int run_test(web100_agent* agent, int ctlsockfd, TestOptions* testopt,
+int run_test(tcp_stat_agent agent, int ctlsockfd, TestOptions* testopt,
              char *test_suite) {
+  tcp_stat_connection conn;
   char date[32];  // date indicator
   char spds[4][256];  // speed "bin" array containing counters for speeds
   char logstr1[4096], logstr2[1024];  // log
@@ -908,18 +925,10 @@
   char isoTime[64];
 
   // int n;  // temporary iterator variable --// commented out -> calc_linkspeed
-  int Timeouts, SumRTT, CountRTT, PktsRetrans, FastRetran, DataPktsOut;
-  int AckPktsOut, CurrentMSS, DupAcksIn, AckPktsIn, MaxRwinRcvd, Sndbuf;
-  int CurrentCwnd, SndLimTimeRwin, SndLimTimeCwnd, SndLimTimeSender,
-      DataBytesOut;
-  int SndLimTransRwin, SndLimTransCwnd, SndLimTransSender, MaxSsthresh;
-  int CurrentRTO, CurrentRwinRcvd, MaxCwnd, CongestionSignals, PktsOut,
-      MinRTT;
-  int CongAvoid, CongestionOverCount, MaxRTT, OtherReductions,
-      CurTimeoutCount = 0;
-  int AbruptTimeouts, SendStall, SlowStart, SubsequentTimeouts,
-      ThruBytesAcked;
-  int RcvWinScale, SndWinScale;
+  
+  /* TCP variables used in calculations */
+  struct tcp_vars vars;
+  
   int link = CANNOT_DETERMINE_LINK;  // local temporary variable indicative of
   // link speed. Transmitted but unused at client end , which has a similar
   // link speed variable
@@ -974,8 +983,6 @@
 
   FILE * fp;
 
-  web100_connection* conn;
-
   // start with a clean slate of currently running test and direction
   setCurrentTest(TEST_NONE);
   log_println(7, "Remote host= %s", get_remotehost());
@@ -989,11 +996,11 @@
     for (ret = 0; ret < 256; ret++)
       spds[spd_index][ret] = 0x00;
   spd_index = 0;
-
+  
   // obtain web100 connection and check auto-tune status
-  conn = web100_connection_from_socket(agent, ctlsockfd);
-  autotune = web100_autotune(ctlsockfd, agent, conn);
-
+  conn = tcp_stat_connection_from_socket(agent, ctlsockfd);
+  autotune = tcp_stat_autotune(ctlsockfd, agent, conn);
+  
   // client needs to be version compatible. Send current version
   snprintf(buff, sizeof(buff), "v%s", VERSION);
   send_msg(ctlsockfd, MSG_LOGIN, buff, strlen(buff));
@@ -1086,75 +1093,70 @@
   // Get web100 vars
 
   // ...determine number of times congestion window has been changed
+#ifdef FORCE_WEB100
   if (options.cwndDecrease) {
     dec_cnt = inc_cnt = same_cnt = 0;
     CwndDecrease(agent, options.s2c_logname, &dec_cnt, &same_cnt, &inc_cnt);
     log_println(2, "####### decreases = %d, increases = %d, no change = %d",
                 dec_cnt, inc_cnt, same_cnt);
   }
-
+#endif 
+/* TODO remove #ifdef once CwndDecrease has a web10g version 
+ * looks like these variables dec_cnt ... are only used here and logged.*/
+  
   // ...other variables
-  web100_logvars(&Timeouts, &SumRTT, &CountRTT, &PktsRetrans, &FastRetran,
-                 &DataPktsOut, &AckPktsOut, &CurrentMSS, &DupAcksIn, &AckPktsIn,
-                 &MaxRwinRcvd, &Sndbuf, &CurrentCwnd, &SndLimTimeRwin,
-                 &SndLimTimeCwnd, &SndLimTimeSender, &DataBytesOut,
-                 &SndLimTransRwin, &SndLimTransCwnd, &SndLimTransSender,
-                 &MaxSsthresh, &CurrentRTO, &CurrentRwinRcvd, &MaxCwnd,
-                 &CongestionSignals, &PktsOut, &MinRTT, count_vars,
-                 &RcvWinScale, &SndWinScale, &CongAvoid, &CongestionOverCount,
-                 &MaxRTT, &OtherReductions, &CurTimeoutCount, &AbruptTimeouts,
-                 &SendStall, &SlowStart, &SubsequentTimeouts, &ThruBytesAcked);
+  tcp_stat_logvars(&vars, count_vars);
 
   // end getting web100 variable values
   /* if (rc == 0) { */
 
   // section to calculate duplex mismatch
   // Calculate average round trip time and convert to seconds
-  rttsec = calc_avg_rtt(SumRTT, CountRTT, &avgrtt);
+  rttsec = calc_avg_rtt(vars.SumRTT, vars.CountRTT, &avgrtt);
   // Calculate packet loss
-  packetloss_s2c = calc_packetloss(CongestionSignals, PktsOut,
+  packetloss_s2c = calc_packetloss(vars.CongestionSignals, vars.PktsOut,
                                    c2s_linkspeed_data);
 
   // Calculate ratio of packets arriving out of order
-  oo_order = calc_packets_outoforder(DupAcksIn, AckPktsIn);
+  oo_order = calc_packets_outoforder(vars.DupAcksIn, vars.AckPktsIn);
 
   // calculate theoretical maximum goodput in bits
-  bw_theortcl = calc_max_theoretical_throughput(CurrentMSS, rttsec,
+  bw_theortcl = calc_max_theoretical_throughput(vars.CurrentMSS, rttsec,
                                                 packetloss_s2c);
 
   // get window sizes
-  calc_window_sizes(&SndWinScale, &RcvWinScale, Sndbuf, MaxRwinRcvd,
-                    MaxCwnd, &rwin, &swin, &cwin);
+  calc_window_sizes(&vars.SndWinScale, &vars.RcvWinScale, vars.Sndbuf, vars.MaxRwinRcvd,
+                    vars.MaxCwnd, &rwin, &swin, &cwin);
 
   // Total test time
-  totaltime = calc_totaltesttime(SndLimTimeRwin, SndLimTimeCwnd,
-                                 SndLimTimeSender);
+  totaltime = calc_totaltesttime(vars.SndLimTimeRwin, vars.SndLimTimeCwnd,
+                                 vars.SndLimTimeSender);
 
   // time spent being send-limited due to client's recv window
-  rwintime = calc_sendlimited_rcvrfault(SndLimTimeRwin, totaltime);
+  rwintime = calc_sendlimited_rcvrfault(vars.SndLimTimeRwin, totaltime);
 
   // time spent in being send-limited due to congestion window
-  cwndtime = calc_sendlimited_cong(SndLimTimeCwnd, totaltime);
+  cwndtime = calc_sendlimited_cong(vars.SndLimTimeCwnd, totaltime);
 
   // time spent in being send-limited due to own fault
-  sendtime = calc_sendlimited_sndrfault(SndLimTimeSender, totaltime);
+  sendtime = calc_sendlimited_sndrfault(vars.SndLimTimeSender, totaltime);
 
   timesec = totaltime / MEGA;  // total time in microsecs
 
   // get fraction of total test time waiting for packets to arrive
-  RTOidle = calc_RTOIdle(Timeouts, CurrentRTO, timesec);
+  RTOidle = calc_RTOIdle(vars.Timeouts, vars.CurrentRTO, timesec);
 
   // get timeout, retransmission, acks and dup acks ratios.
-  tmoutsratio = (double) Timeouts / PktsOut;
-  rtranratio = (double) PktsRetrans / PktsOut;
-  acksratio = (double) AckPktsIn / PktsOut;
-  dackratio = (double) DupAcksIn / (double) AckPktsIn;
+  tmoutsratio = (double) vars.Timeouts / vars.PktsOut;
+  rtranratio = (double) vars.PktsRetrans / vars.PktsOut;
+  acksratio = (double) vars.AckPktsIn / vars.PktsOut;
+  dackratio = (double) vars.DupAcksIn / (double) vars.AckPktsIn;
 
   // get actual throughput in Mbps (totaltime is in microseconds)
-  realthruput = calc_real_throughput(DataBytesOut, totaltime);
+  realthruput = calc_real_throughput(vars.DataBytesOut, totaltime);
 
   // total time spent waiting
-  waitsec = cal_totalwaittime(CurrentRTO, Timeouts);
+  waitsec = cal_totalwaittime(vars.CurrentRTO, vars.Timeouts);
 
   log_println(2, "CWND limited test = %0.2f while unlimited = %0.2f", s2c2spd,
               s2cspd);
@@ -1175,8 +1177,8 @@
   old_mismatch = 1;
 
   if (old_mismatch == 1) {
-    if (detect_duplexmismatch(cwndtime, bw_theortcl, PktsRetrans, timesec,
-                              MaxSsthresh, RTOidle, link, s2cspd, s2c2spd,
+    if (detect_duplexmismatch(cwndtime, bw_theortcl, vars.PktsRetrans, timesec,
+                              vars.MaxSsthresh, RTOidle, link, s2cspd, s2c2spd,
                               multiple)) {
       if (is_c2s_throughputbetter(c2sspd, s2cspd)) {
         // also, S->C throughput is lesser than C->S throughput
@@ -1213,7 +1215,7 @@
 
   // Faulty hardware link heuristic.
   if (detect_faultyhardwarelink(packetloss_s2c, cwndtime, timesec,
-                                MaxSsthresh))
+                                vars.MaxSsthresh))
     bad_cable = POSSIBLE_BAD_CABLE;
 
   // test for Ethernet link (assume Fast E.)
@@ -1222,12 +1224,12 @@
     link = LINK_ETHERNET;
 
   // test for wireless link
-  if (detect_wirelesslink(sendtime, realthruput, bw_theortcl, SndLimTransRwin,
-                          SndLimTransCwnd, rwintime, link))
+  if (detect_wirelesslink(sendtime, realthruput, bw_theortcl, vars.SndLimTransRwin,
+                          vars.SndLimTransCwnd, rwintime, link))
     link = LINK_WIRELESS;
 
   // test for DSL/Cable modem link
-  if (detect_DSLCablelink(SndLimTimeSender, SndLimTransSender, realthruput,
+  if (detect_DSLCablelink(vars.SndLimTimeSender, vars.SndLimTransSender, realthruput,
                           bw_theortcl, link))
     link = LINK_DSLORCABLE;
 
@@ -1238,7 +1240,7 @@
   //  ...and the number of transitions into the 'Sender Limited' state is
   //  greater than 30 per second
 
-  if (detect_halfduplex(rwintime, SndLimTransRwin, SndLimTransSender,
+  if (detect_halfduplex(rwintime, vars.SndLimTransRwin, vars.SndLimTransSender,
                         timesec))
     half_duplex = POSSIBLE_HALF_DUPLEX;
 
@@ -1272,7 +1274,7 @@
 
   snprintf(buff, sizeof(buff),
            "cwin: %0.4f\nrttsec: %0.6f\nSndbuf: %d\naspd: %0.5f\n"
-           "CWND-Limited: %0.2f\n", cwin, rttsec, Sndbuf, aspd, s2c2spd);
+           "CWND-Limited: %0.2f\n", cwin, rttsec, vars.Sndbuf, aspd, s2c2spd);
   send_msg(ctlsockfd, MSG_RESULTS, buff, strlen(buff));
 
   snprintf(buff, sizeof(buff),
@@ -1295,15 +1297,15 @@
 
   memset(tmpstr, 0, sizeof(tmpstr));
   snprintf(tmpstr, sizeof(tmpstr), "%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,",
-           (int) s2c2spd, (int) s2cspd, (int) c2sspd, Timeouts, SumRTT,
-           CountRTT, PktsRetrans, FastRetran, DataPktsOut, AckPktsOut,
-           CurrentMSS, DupAcksIn, AckPktsIn);
+           (int) s2c2spd, (int) s2cspd, (int) c2sspd, vars.Timeouts, vars.SumRTT,
+           vars.CountRTT, vars.PktsRetrans, vars.FastRetran, vars.DataPktsOut, vars.AckPktsOut,
+           vars.CurrentMSS, vars.DupAcksIn, vars.AckPktsIn);
   memcpy(meta.summary, tmpstr, strlen(tmpstr));
   memset(tmpstr, 0, sizeof(tmpstr));
   snprintf(tmpstr, sizeof(tmpstr), "%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,",
-           MaxRwinRcvd, Sndbuf, MaxCwnd, SndLimTimeRwin, SndLimTimeCwnd,
-           SndLimTimeSender, DataBytesOut, SndLimTransRwin, SndLimTransCwnd,
-           SndLimTransSender, MaxSsthresh, CurrentRTO, CurrentRwinRcvd);
+           vars.MaxRwinRcvd, vars.Sndbuf, vars.MaxCwnd, vars.SndLimTimeRwin, vars.SndLimTimeCwnd,
+           vars.SndLimTimeSender, vars.DataBytesOut, vars.SndLimTransRwin, vars.SndLimTransCwnd,
+           vars.SndLimTransSender, vars.MaxSsthresh, vars.CurrentRTO, vars.CurrentRwinRcvd);
 
   strlcat(meta.summary, tmpstr, sizeof(meta.summary));
   memset(tmpstr, 0, sizeof(tmpstr));
@@ -1314,15 +1316,15 @@
   memset(tmpstr, 0, sizeof(tmpstr));
   snprintf(tmpstr, sizeof(tmpstr), ",%d,%d,%d,%d,%d,%d,%d,%d,%d",
            c2s_linkspeed_data, c2s_linkspeed_ack, s2c_linkspeed_data,
-           s2c_linkspeed_ack, CongestionSignals, PktsOut, MinRTT, RcvWinScale,
+           s2c_linkspeed_ack, vars.CongestionSignals, vars.PktsOut, vars.MinRTT, vars.RcvWinScale,
            autotune);
 
   strlcat(meta.summary, tmpstr, sizeof(meta.summary));
   memset(tmpstr, 0, sizeof(tmpstr));
-  snprintf(tmpstr, sizeof(tmpstr), ",%d,%d,%d,%d,%d,%d,%d,%d,%d,%d", CongAvoid,
-           CongestionOverCount, MaxRTT, OtherReductions, CurTimeoutCount,
-           AbruptTimeouts, SendStall, SlowStart, SubsequentTimeouts,
-           ThruBytesAcked);
+  snprintf(tmpstr, sizeof(tmpstr), ",%d,%d,%d,%d,%d,%d,%d,%d,%d,%d", vars.CongAvoid,
+           vars.CongestionOverCount, vars.MaxRTT, vars.OtherReductions, vars.CurTimeoutCount,
+           vars.AbruptTimeouts, vars.SendStall, vars.SlowStart, vars.SubsequentTimeouts,
+           vars.ThruBytesAcked);
 
   strlcat(meta.summary, tmpstr, sizeof(meta.summary));
   memset(tmpstr, 0, sizeof(tmpstr));
@@ -1342,39 +1344,39 @@
     snprintf(date, sizeof(date), "%15.15s", ctime(&stime) + 4);
     fprintf(fp, "%s,", date);
     fprintf(fp, "%s,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,", rmt_host,
-            (int) s2c2spd, (int) s2cspd, (int) c2sspd, Timeouts, SumRTT,
-            CountRTT, PktsRetrans, FastRetran, DataPktsOut, AckPktsOut,
-            CurrentMSS, DupAcksIn, AckPktsIn);
-    fprintf(fp, "%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,", MaxRwinRcvd,
-            Sndbuf, MaxCwnd, SndLimTimeRwin, SndLimTimeCwnd,
-            SndLimTimeSender, DataBytesOut, SndLimTransRwin,
-            SndLimTransCwnd, SndLimTransSender, MaxSsthresh, CurrentRTO,
-            CurrentRwinRcvd);
+            (int) s2c2spd, (int) s2cspd, (int) c2sspd, vars.Timeouts, vars.SumRTT,
+            vars.CountRTT, vars.PktsRetrans, vars.FastRetran, vars.DataPktsOut, vars.AckPktsOut,
+            vars.CurrentMSS, vars.DupAcksIn, vars.AckPktsIn);
+    fprintf(fp, "%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,", vars.MaxRwinRcvd,
+            vars.Sndbuf, vars.MaxCwnd, vars.SndLimTimeRwin, vars.SndLimTimeCwnd,
+            vars.SndLimTimeSender, vars.DataBytesOut, vars.SndLimTransRwin,
+            vars.SndLimTransCwnd, vars.SndLimTransSender, vars.MaxSsthresh, vars.CurrentRTO,
+            vars.CurrentRwinRcvd);
     fprintf(fp, "%d,%d,%d,%d,%d", link, mismatch, bad_cable, half_duplex,
             congestion);
     fprintf(fp, ",%d,%d,%d,%d,%d,%d,%d,%d,%d", c2s_linkspeed_data,
             c2s_linkspeed_ack, s2c_linkspeed_data, s2c_linkspeed_ack,
-            CongestionSignals, PktsOut, MinRTT, RcvWinScale, autotune);
-    fprintf(fp, ",%d,%d,%d,%d,%d,%d,%d,%d,%d,%d", CongAvoid,
-            CongestionOverCount, MaxRTT, OtherReductions, CurTimeoutCount,
-            AbruptTimeouts, SendStall, SlowStart, SubsequentTimeouts,
-            ThruBytesAcked);
+            vars.CongestionSignals, vars.PktsOut, vars.MinRTT, vars.RcvWinScale, autotune);
+    fprintf(fp, ",%d,%d,%d,%d,%d,%d,%d,%d,%d,%d", vars.CongAvoid,
+            vars.CongestionOverCount, vars.MaxRTT, vars.OtherReductions, vars.CurTimeoutCount,
+            vars.AbruptTimeouts, vars.SendStall, vars.SlowStart, vars.SubsequentTimeouts,
+            vars.ThruBytesAcked);
     fprintf(fp, ",%d,%d,%d\n", peaks.min, peaks.max, peaks.amount);
     fclose(fp);
   }
   db_insert(spds, runave, cputimelog, options.s2c_logname,
             options.c2s_logname, testName, testPort, date, rmt_host, s2c2spd,
-            s2cspd, c2sspd, Timeouts, SumRTT, CountRTT, PktsRetrans, FastRetran,
-            DataPktsOut, AckPktsOut, CurrentMSS, DupAcksIn, AckPktsIn,
-            MaxRwinRcvd, Sndbuf, MaxCwnd, SndLimTimeRwin, SndLimTimeCwnd,
-            SndLimTimeSender, DataBytesOut, SndLimTransRwin, SndLimTransCwnd,
-            SndLimTransSender, MaxSsthresh, CurrentRTO, CurrentRwinRcvd, link,
+            s2cspd, c2sspd, vars.Timeouts, vars.SumRTT, vars.CountRTT, vars.PktsRetrans, vars.FastRetran,
+            vars.DataPktsOut, vars.AckPktsOut, vars.CurrentMSS, vars.DupAcksIn, vars.AckPktsIn,
+            vars.MaxRwinRcvd, vars.Sndbuf, vars.MaxCwnd, vars.SndLimTimeRwin, vars.SndLimTimeCwnd,
+            vars.SndLimTimeSender, vars.DataBytesOut, vars.SndLimTransRwin, vars.SndLimTransCwnd,
+            vars.SndLimTransSender, vars.MaxSsthresh, vars.CurrentRTO, vars.CurrentRwinRcvd, link,
             mismatch, bad_cable, half_duplex, congestion, c2s_linkspeed_data,
             c2s_linkspeed_ack, s2c_linkspeed_data, s2c_linkspeed_ack,
-            CongestionSignals, PktsOut, MinRTT, RcvWinScale, autotune,
-            CongAvoid, CongestionOverCount, MaxRTT, OtherReductions,
-            CurTimeoutCount, AbruptTimeouts, SendStall, SlowStart,
-            SubsequentTimeouts, ThruBytesAcked, peaks.min, peaks.max,
+            vars.CongestionSignals, vars.PktsOut, vars.MinRTT, vars.RcvWinScale, autotune,
+            vars.CongAvoid, vars.CongestionOverCount, vars.MaxRTT, vars.OtherReductions,
+            vars.CurTimeoutCount, vars.AbruptTimeouts, vars.SendStall, vars.SlowStart,
+            vars.SubsequentTimeouts, vars.ThruBytesAcked, peaks.min, peaks.max,
             peaks.amount);
   if (usesyslog == 1) {
     snprintf(
@@ -1382,19 +1384,19 @@
         "client_IP=%s,c2s_spd=%2.0f,s2c_spd=%2.0f,Timeouts=%d,SumRTT=%d,"
         "CountRTT=%d,PktsRetrans=%d,FastRetran=%d,DataPktsOut=%d,AckPktsOut=%d,"
         "CurrentMSS=%d,DupAcksIn=%d,AckPktsIn=%d,",
-        rmt_host, c2sspd, s2cspd, Timeouts, SumRTT, CountRTT,
-        PktsRetrans, FastRetran, DataPktsOut, AckPktsOut, CurrentMSS,
-        DupAcksIn, AckPktsIn);
+        rmt_host, c2sspd, s2cspd, vars.Timeouts, vars.SumRTT, vars.CountRTT,
+        vars.PktsRetrans, vars.FastRetran, vars.DataPktsOut, vars.AckPktsOut, vars.CurrentMSS,
+        vars.DupAcksIn, vars.AckPktsIn);
     snprintf(
         logstr2, sizeof(logstr2),
         "MaxRwinRcvd=%d,Sndbuf=%d,MaxCwnd=%d,SndLimTimeRwin=%d,"
         "SndLimTimeCwnd=%d,SndLimTimeSender=%d,DataBytesOut=%d,"
         "SndLimTransRwin=%d,SndLimTransCwnd=%d,SndLimTransSender=%d,"
         "MaxSsthresh=%d,CurrentRTO=%d,CurrentRwinRcvd=%d,",
-        MaxRwinRcvd, Sndbuf, MaxCwnd, SndLimTimeRwin, SndLimTimeCwnd,
-        SndLimTimeSender, DataBytesOut, SndLimTransRwin,
-        SndLimTransCwnd, SndLimTransSender, MaxSsthresh, CurrentRTO,
-        CurrentRwinRcvd);
+        vars.MaxRwinRcvd, vars.Sndbuf, vars.MaxCwnd, vars.SndLimTimeRwin, vars.SndLimTimeCwnd,
+        vars.SndLimTimeSender, vars.DataBytesOut, vars.SndLimTransRwin,
+        vars.SndLimTransCwnd, vars.SndLimTransSender, vars.MaxSsthresh, vars.CurrentRTO,
+        vars.CurrentRwinRcvd);
     strlcat(logstr1, logstr2, sizeof(logstr1));
     snprintf(
         logstr2, sizeof(logstr2),
@@ -1403,7 +1405,7 @@
         "CongestionSignals=%d,PktsOut=%d,MinRTT=%d,RcvWinScale=%d\n",
         link, mismatch, bad_cable, half_duplex, congestion, c2s_linkspeed_data,
         c2s_linkspeed_ack, s2c_linkspeed_data, s2c_linkspeed_ack,
-        CongestionSignals, PktsOut, MinRTT, RcvWinScale);
+        vars.CongestionSignals, vars.PktsOut, vars.MinRTT, vars.RcvWinScale);
     strlcat(logstr1, logstr2, sizeof(logstr1));
     syslog(LOG_FACILITY | LOG_INFO, "%s", logstr1);
     closelog();
@@ -1421,14 +1423,14 @@
    * updated.  Otherwise the changes are lost when the client terminates.
    */
   if (admin_view == 1) {
-    totalcnt = calculate(date, SumRTT, CountRTT, CongestionSignals, PktsOut,
-                         DupAcksIn, AckPktsIn, CurrentMSS, SndLimTimeRwin,
-                         SndLimTimeCwnd, SndLimTimeSender, MaxRwinRcvd,
-                         CurrentCwnd, Sndbuf, DataBytesOut, mismatch, bad_cable,
+    totalcnt = calculate(date, vars.SumRTT, vars.CountRTT, vars.CongestionSignals, vars.PktsOut,
+                         vars.DupAcksIn, vars.AckPktsIn, vars.CurrentMSS, vars.SndLimTimeRwin,
+                         vars.SndLimTimeCwnd, vars.SndLimTimeSender, vars.MaxRwinRcvd,
+                         vars.CurrentCwnd, vars.Sndbuf, vars.DataBytesOut, mismatch, bad_cable,
                          (int) c2sspd, (int) s2cspd, c2s_linkspeed_data,
                          s2c_linkspeed_ack, 1);
-    gen_html((int) c2sspd, (int) s2cspd, MinRTT, PktsRetrans, Timeouts,
-             Sndbuf, MaxRwinRcvd, CurrentCwnd, mismatch, bad_cable, totalcnt,
+    gen_html((int) c2sspd, (int) s2cspd, vars.MinRTT, vars.PktsRetrans, vars.Timeouts,
+             vars.Sndbuf, vars.MaxRwinRcvd, vars.CurrentCwnd, mismatch, bad_cable, totalcnt,
              refresh);
   }
   shutdown(ctlsockfd, SHUT_WR);
@@ -1444,16 +1446,22 @@
  * @param argc Number of arguments
  * @param argv string command line arguments
  * */
-int main(int argc, char** argv) {
+ int main(int argc, char** argv) {
+#ifndef FORCE_WEB100
+ /* web10g */
+  struct tcpe_error* err = NULL;
+#endif
+  tcp_stat_agent agent = NULL;
   pid_t chld_pid = -1;
   int retcode;
   int tpid, mwaiting = 0;
   int ctlsockfd = -1;
   int c, chld_pipe[2];
   int i, loopcnt, t_opts = 0;
+  int kernel_config = 0;
   struct sockaddr_storage cli_addr;
   struct sigaction new;
-  web100_agent* agent;
+ 
   char *lbuf = NULL, *ctime();
   char buff[32], tmpstr[256];
   char test_suite[16];
@@ -1464,7 +1472,6 @@
   struct ndtchild *tmp_ptr = NULL, *new_child = NULL, *mchild = NULL;
   time_t tt;
   socklen_t clilen;
-
   I2Addr listenaddr = NULL;
   int listenfd;
   char* srcname = NULL;
@@ -1555,7 +1562,7 @@
               argc,
               argv,
               GETOPT_LONG_INET6(
-                  GETOPT_LONG_EXP("adhmoqrstvzc:x:b:f:i:l:u:e:p:T:A:S:")),
+                  GETOPT_LONG_EXP("adhmoqrstvzc:x:b:f:i:l:u:e:p:T:A:S:k")),
               long_options, 0)) != -1) {
                 switch (c) {
                   case '4':
@@ -1616,7 +1623,11 @@
                     admin_view = 1;
                     break;
                   case 'f':
+#ifdef FORCE_WEB100
                     VarFileName = optarg;
+#else /* Web10G */
+                    log_println(2, "WEB10g doesn't need a varfile, ignored");
+#endif
                     break;
                   case 'i':
                     device = optarg;
@@ -1715,6 +1726,9 @@
                   case '?':
                     short_usage(argv[0], "");
                     break;
+                  case 'k':
+                    kernel_config = 1;
+                    break;
                 }
               }
 
@@ -1817,11 +1831,17 @@
     err_sys("server: CreateListenSocket failed");
   }
   listenfd = I2AddrFD(listenaddr);
-
+  
+  if(listenfd == -1){
+    /* If socket isn't opened this will segfault at FDSET for the select */
+    log_println(0, "ERROR: Socket already in use this wont work");
+    return 0;
+  }
   log_println(1, "server ready on port %s", port);
 
-  // Initialize Web100 structures
-  count_vars = web100_init(VarFileName);
+  /* Initialize Web100 structures */
+  count_vars = tcp_stat_init(VarFileName);
+
   if (count_vars == -1) {
     log_println(0, "No web100 variables file found, terminating program");
     exit(-5);
@@ -1889,7 +1909,18 @@
   //  RAC 7/14/09
 
   get_iflist();
+  disable_coalesce(kernel_config);
+  check_kernel(kernel_config);
 
+#ifndef FORCE_WEB100
+  if(start_tcpe() == -1){
+    log_println(0, "FATAL: Web10G module cannot be loaded into kernel\n"
+                    "\t - Either sudo modprobe tcp_estats_nl yourself\n"
+                    "\t - or run this program as superuser\n");
+    return 1;
+  }
+#endif
+  
   for (i = 0; iflist.speed[i] > 0; i++)
     log_println(4, "Generated iflist with device=%s and if_speed=%d",
                 iflist.name[i], iflist.speed[i]);
@@ -1923,11 +1954,6 @@
                 "zombie_check=%d",
                 head_ptr->pid, testing, waiting, mclients, zombie_check);
 
-          // moved condition from interrupt handler to here
-          /* if ((sig1 > 0) || (sig2 > 0))
-           * 	check_signal_flags;
-           */
-
           if (sig13 == 1) {
             log_println(5, "todo: Handle SIGPIPE signal, terminate child?");
             child_sig(0);
@@ -2099,7 +2125,7 @@
                           mclients);
             }
           }
-
+          
           FD_ZERO(&rfd);
           FD_SET(listenfd, &rfd);
           if (waiting > 0) {  // there are clients waiting
@@ -2599,11 +2625,18 @@
                           "pid=%d", chld_pipe[0], chld_pipe[1], chld_pid);
               close(listenfd);
               close(chld_pipe[1]);
+#ifdef FORCE_WEB100
               if ((agent = web100_attach(WEB100_AGENT_TYPE_LOCAL,
                                          NULL)) == NULL) {
                 web100_perror("web100_attach");
                 return 1;
               }
+#else
+              if (tcpe_client_init(&agent) != NULL ){
+                  log_println(0, "Error: tcpe_client_init failed unable to use web10g");
+                  return 1;
+              }
+#endif 
 
               // This is the child process from the above fork().  The parent
               //  is in control, and will send this child a signal when it gets
@@ -2727,7 +2760,11 @@
                 child_sig(0);
               }
               close(ctlsockfd);
+#ifdef FORCE_WEB100
               web100_detach(agent);
+#else
+              tcpe_client_destroy(&agent);
+#endif
               log_free();
 
               if (cputime && workerThreadId) {
@@ -2755,6 +2792,11 @@
               break;
           }
   }
+  revert_coalesce();
+  revert_congestion();
+#ifndef FORCE_WEB100
+  revert_tcpe();
+#endif
 }
 
 /**
Index: configure.ac
===================================================================
--- configure.ac	(revision 796)
+++ configure.ac	(working copy)
@@ -145,6 +145,18 @@
                INCLUDED_WEB100LIB=""
                AM_CONDITIONAL(HAVE_WEB100, false)
                ])
+AC_CHECK_LIB([tcpe], [tcpe_client_init],
+             [
+              LINKED_TCPELIB="-ltcpe"
+              INCLUDED_TCPELIB="-I/usr/local/include/tcpe"
+              AC_DEFINE(HAVE_LIBTCPE, 1, [Define to 1 if you have the 'Web10G' library (-ltcpe).])
+              AM_CONDITIONAL(HAVE_TCPE, true)
+              ],
+              [
+               LINKED_TCPELIB=""
+               INCLUDED_TCPELIB=""
+               AM_CONDITIONAL(HAVE_TCPE, false)
+               ])
 
 AC_CHECK_LIB([pcap], [pcap_open_live],
              [
@@ -197,14 +209,16 @@
                ])
 
 
-NDTINCDIR='$(INCLUDED_WEB100LIB) $(INCLUDED_PCAPLIB)'
+NDTINCDIR='$(INCLUDED_WEB100LIB) $(INCLUDED_PCAPLIB) $(INCLUDED_TCPELIB)'
 NDTLIBDIR=/usr/local/lib
 NDTLDFLAGS='-L$(NDTLIBDIR) -Wl,-rpath,$(NDTLIBDIR)'
-NDTLIBS='$(LINKED_WEB100LIB) $(LINKED_PCAPLIB) $(LINKED_ODBCLIB) -lm'
+NDTLIBS='$(LINKED_WEB100LIB) $(LINKED_PCAPLIB) $(LINKED_ODBCLIB) $(LINKED_TCPELIB) -lm'
 NDTINCS='-I$(NDTINCDIR)'
 
 AC_SUBST(LINKED_WEB100LIB)
 AC_SUBST(INCLUDED_WEB100LIB)
+AC_SUBST(LINKED_TCPELIB)
+AC_SUBST(INCLUDED_TCPELIB)
 AC_SUBST(LINKED_PCAPLIB)
 AC_SUBST(INCLUDED_PCAPLIB)
 AC_SUBST(LINKED_ODBCLIB)
@@ -275,6 +289,12 @@
 echo ""
 echo ""
 
+if test -z "$HAVE_TCPE_TRUE" && test -n "$HAVE_TCPE_FALSE"; then
+SUMMARY_WEB10GSRV="YES"
+else
+SUMMARY_WEB10GSRV="NO (missing tcpe (web10g) library)"
+fi
+
 SUMMARY_WEB100CLT="YES"
 if test -z "$HAVE_WEB100_TRUE" && test -n "$HAVE_WEB100_FALSE"; then
 if test -z "$HAVE_PCAP_H_TRUE" && test -n "$HAVE_PCAP_H_FALSE"; then
@@ -314,13 +334,14 @@
 echo "* web100clt:    ${SUMMARY_WEB100CLT}"
 echo ""
 
-if test "$SUMMARY_FAKEWWW" = "YES" && test "$SUMMARY_WEB100SRV" = "YES" && test "$SUMMARY_TCPBW100JAR" = "YES"; then
+if test "$SUMMARY_FAKEWWW" = "YES" && (test "$SUMMARY_WEB100SRV" = "YES" || test "$SUMMARY_WEB10GSRV" = "YES") && test "$SUMMARY_TCPBW100JAR" = "YES"; then
 echo "*** Server Tools - complete"
 else
 echo "*** Server Tools - incomplete"
 fi
 echo "* fakewww:      ${SUMMARY_FAKEWWW}"
 echo "* web100srv:    ${SUMMARY_WEB100SRV}"
+echo "* web10gsrv:    ${SUMMARY_WEB10GSRV}"
 echo "* Tcpbw100.jar: ${SUMMARY_TCPBW100JAR}"
 echo ""
 
